#!/bin/sh
# ---------------------------------------------------------------------------
# The TongWeb Server Start Script
#
# Environment Variable Prequisites
#
#   JAVA_HOME       Point at your Java Development Kit installation. If you
#                   don't want to use the JDK specified by JAVA_HOME, define
#                   JDKDIR in this script.
#
#
# Configurable Variables in this Script
#
#   JDKDIR          Point at your Java Development Kit installation. If not
#                   specified, JAVA_HOME will be used.
#
#   JAVA_OPTS       Additional java arguments.
#
# ---------------------------------------------------------------------------
DIRNAME=`pwd` 

# if [ "${JAVA_HOME}" = "" ] ; then
# 	echo ERROR: JAVA_HOME was not setted
#	exit 1
# fi
JAVA=java
# if [ ! "${JAVA_HOME}/lib/tools.jar" ] ; then
#	echo ERROR: JAVA_HOME directory is wrong.
#        exit 1
# fi

# Get standard environment variables
PRGDIR=`dirname "$PRG"`
HOME=`cd "$PRGDIR" >/dev/null; pwd`

if [ "${OSTYPE}" = "cygwin32" ] ; then
    PS=\;
else
    PS=:
fi

JDK_JAVA_OPTIONS="$JDK_JAVA_OPTIONS --add-opens java.base/java.lang=ALL-UNNAMED"
JDK_JAVA_OPTIONS="$JDK_JAVA_OPTIONS --add-opens java.base/sun.net.util=ALL-UNNAMED"
JDK_JAVA_OPTIONS="$JDK_JAVA_OPTIONS --add-opens java.base/java.util=ALL-UNNAMED"
JDK_JAVA_OPTIONS="$JDK_JAVA_OPTIONS --add-opens java.base/java.lang.reflect=ALL-UNNAMED"
export JDK_JAVA_OPTIONS

TW_OPTS="-Dhome=${HOME} -Dtools.base=${HOME}"
CLASSPATH=${HOME}/TW-toolkit.jar:${HOME}/lib/bootstrap.jar:${HOME}/lib/tongweb.jar
CLASSPATH=${CLASSPATH}:${HOME}/lib/jdk-api.jar:${HOME}/lib/jdk-impl.jar:${HOME}/lib/activation-api.jar

#START_CLASS=com.tongweb.migration.TongWebStarter
START_CLASS=com.tongweb.migration.MigrationToolStarter

ACTION=start
# parse arguments
#if [ $# -gt 1 ] ; then
#ACTION=error
#echo ERROR : error argument
#elif [ $# = 0 ] ; then 
#ACTION=error
#echo ERROR : at least one argument for migration.sh
#fi

#execute
if [ "${ACTION}" = "start" ] ; then   
   exec ${JAVA} -classpath ${CLASSPATH} ${TW_OPTS} ${START_CLASS} 
#elif [ "${ACTION}" = "error" ] ; then
#   echo permitting argument as follow : 
#   echo "    1      tomcat6 to tongweb7"
#   echo "    2      tomcat7 to tongweb7"
#   echo "    3      tomcat8 to tongweb7"
fi
