@echo off
if "%Domain_Base%" == "" (
    set "TongWeb_Base=%cd%\.."
) else (
    set "TongWeb_Base=%Domain_Base%"
)
cd /d %~dp0
set "TongWeb_Home=%cd%\.."
if exist "%TongWeb_Base%\conf\tongweb.xml" goto OK_HOME
echo The TongWeb_Base environment variable is not defined correctly
echo This environment variable is needed to run this program
goto end

:OK_HOME
call "%TongWeb_Home%\conf\environment.bat"
if "%JAVA_HOME%" == "" (
    set JAVA=java
) else (
    set JAVA=%JAVA_HOME%\bin\java
)

set DEBUG_ADDRESS=%2
set FETCH_EXTERNAL_CLASSPATH="%TongWeb_Home%/lib/bootstrap.jar"

if "%JAVA_HOME%" == "" (
    "%JAVA%" -cp %FETCH_EXTERNAL_CLASSPATH% com.tongweb.server.JavaHome > bat_java.log
    for /f "delims=" %%x in (bat_java.log) do set JAVA_HOME=%%x
    del bat_java.log
)

set FETCH_EXTERNAL_OPTS=-Dtongweb.home="%TongWeb_Home%" -Dtongweb.base="%TongWeb_Base%" -Dtongweb.java="%JAVA_HOME%"
set FETCH_CLASS=com.tongweb.server.ExternalOptions
set JAVA_CMD=%JAVA%

rem -cp "D:\ejbserver7\TW7_1\bin\../lib/bootstrap.jar"
"%JAVA_CMD%" -cp %FETCH_EXTERNAL_CLASSPATH% %FETCH_EXTERNAL_OPTS% %FETCH_CLASS% jvm %1 > bat1.log
for /f "delims=" %%x in (bat1.log) do set JAVA_OPTS=%%x
del bat1.log

"%JAVA_CMD%" -cp %FETCH_EXTERNAL_CLASSPATH% %FETCH_EXTERNAL_OPTS% %FETCH_CLASS% server > bat2.log
for /f "delims=" %%x in (bat2.log) do set TW_OPTS=%%x
del bat2.log

"%JAVA_CMD%" -cp %FETCH_EXTERNAL_CLASSPATH% %FETCH_EXTERNAL_OPTS% -Ddebug.address=%DEBUG_ADDRESS% %FETCH_CLASS%  debug_opt > bat3.log
for /f "delims=" %%x in (bat3.log) do set DEBUG_OPT=%%x
del bat3.log

"%JAVA_CMD%" -cp %FETCH_EXTERNAL_CLASSPATH% %FETCH_EXTERNAL_OPTS% %FETCH_CLASS%  java_home > bat4.log
for /f "delims=" %%x in (bat4.log) do set EXTERNAL_JAVA_HOME=%%x
del bat4.log


if not "%EXTERNAL_JAVA_HOME%" == "" (
    set	JAVA_HOME=%EXTERNAL_JAVA_HOME%
)

if exist "%JAVA_HOME%\lib\tools.jar" goto SKIP_TOOLS

:SKIP_TOOLS
set JAVAC_JAR="%JAVA_HOME%\lib\tools.jar"

set JAVA_VERSION_FILE="%TongWeb_Base%\tmp_java_version.txt"

"%JAVA%" -version 2> %JAVA_VERSION_FILE%

set /p JAVA_VERSION= < %JAVA_VERSION_FILE%
del %JAVA_VERSION_FILE%
rem extract minor version
set JAVA_VERSION=%JAVA_VERSION:~16,1%

rem adjust endorsed lib depending on the java version
set JAVA_ENDORSED_DIRS="%TongWeb_Home%\lib\endorsed"

set APR_LIBRARY_PATH=%TongWeb_Home%/native/windows/x86
) else (
set APR_LIBRARY_PATH=%TongWeb_Home%/native/windows/x64
)

set JAVA_OPTS=%JAVA_OPTS% -Djava.library.path="%APR_LIBRARY_PATH%;%TongWeb_Home%\lib\sigar"

set TW_CLASSPATH=%JAVAC_JAR%
set TW_CLASSPATH=%TW_CLASSPATH%;"%TongWeb_Home%\lib\bootstrap.jar;%TongWeb_Home%\lib\sigar\sigar.jar;%TongWeb_Home%\lib\jdk-api.jar"


rem parse arguments
set ACTION=start
:LOOP
if "%1"=="" goto ENDLOOP
if "%1"=="start" goto START
if "%1"=="stop" goto STOP
if "%1"=="debug"  goto DEBUG
if "%1"=="restart" goto RESTART


goto ENDLOOP

:START
set ACTION=start
shift
goto ENDLOOP


:STOP
set ACTION=stop
shift
goto ENDLOOP


:DEBUG
set ACTION=debug
shift
goto ENDLOOP


:RESTART
set ACTION=restart
shift
goto ENDLOOP

:ENDLOOP


if "%ACTION%"=="start" (
	"%JAVA%" %JAVA_OPTS% %TW_OPTS% %CST_ENV% -classpath %TW_CLASSPATH% com.tongweb.web.thor.startup.ThorBootstrap start
) else if "%ACTION%"=="debug" (
	"%JAVA%" -Xrunjdwp:transport=dt_socket,server=y,suspend=n,address="%1" %JAVA_OPTS% %TW_OPTS% -classpath %TW_CLASSPATH% com.tongweb.web.thor.startup.ThorBootstrap start
) else if "%ACTION%"=="stop" (
	"%JAVA%" %JAVA_OPTS% %TW_OPTS% -classpath %TW_CLASSPATH% com.tongweb.web.thor.startup.ThorBootstrapStop stop
) else if "%ACTION%"=="restart" (
  	"%JAVA%"  -DJAVA_HOME="%JAVA_HOME%" %JAVA_OPTS% %TW_OPTS% -classpath %TW_CLASSPATH% com.tongweb.autoreboot.LauncherMonitor start
)

:END

set JAVA_OPTS=
if "%NOPAUSE%" == "" pause
if "%NOPAUSE%" == "" exit
:END_NO_PAUSE

:LIBAPPEND
set JARS=%JARS%;%1

cd "%CURRENT_DIR%"
